-----------------------------------------------------------------------------

local AloftHealthData = Aloft:NewModule("HealthData", "AceEvent-2.0")

-----------------------------------------------------------------------------

AloftTagDirectAccessData.health = true
AloftTagData.health = { data = "health", events = "Aloft:OnHealthDataChanged", overrideEvents = "Aloft:OnHealthBarValueChanged" }
AloftTagDirectAccessData.maxHealth = true
AloftTagData.maxHealth = { data = "maxHealth", events = "Aloft:OnHealthDataChanged", overrideEvents = "Aloft:OnHealthBarValueChanged" }

function AloftTagMethods.healthDeficit(aloftData, value)
    if value and aloftData.health and aloftData.maxHealth then
        return aloftData.maxHealth - aloftData.health
    else    
        return nil 
    end     
end             
AloftTagData.healthDeficit = { data = { "health", "maxHealth" }, events = "Aloft:OnHealthDataChanged", overrideEvents = "Aloft:OnHealthBarValueChanged" }

function AloftTagMethods.hideKnownHealth(aloftData, value)
    return not aloftData.health and value or nil
end
AloftTagData.maxHealth = { data = "health", events = "Aloft:OnHealthDataChanged", overrideEvents = "Aloft:OnHealthBarValueChanged" }
 
-----------------------------------------------------------------------------

function AloftHealthData:ProvidesData()
	return "health", "maxHealth"
end

-----------------------------------------------------------------------------

function AloftHealthData:EnableDataSource()
	self:RegisterEvent("Aloft:OnHealthBarValueChanged", "OnHealthBarValueChanged")
end

-----------------------------------------------------------------------------

function AloftHealthData:UpdateData(aloftData)
    if aloftData.healthBarMaxValue ~= 100 then
        aloftData.health = aloftData.healthBarValue
        aloftData.maxHealth = aloftData.healthBarMaxValue
    elseif MobHealth3 then
        local health, maxHealth, valid = MobHealth3:GetHealth(aloftData.healthBarValue, aloftData.healthBarMaxValue, aloftData.name, aloftData.level or -1)
        if valid then
            aloftData.health = health
            aloftData.maxHealth = maxHealth
        else
            aloftData.health = nil
            aloftData.maxHealth = nil
        end
    else
        aloftData.health = nil
        aloftData.maxHealth = nil
    end
end

-----------------------------------------------------------------------------

function AloftHealthData:OnHealthBarValueChanged(aloftData)
	self:UpdateData(aloftData)
	self:TriggerEvent("Aloft:OnHealthDataChanged", aloftData)
end

-----------------------------------------------------------------------------
